"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-11558
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.asset_device_registration_relationship import AssetDeviceRegistrationRelationship
    from intersight.model.hyperflex_alarm_relationship import HyperflexAlarmRelationship
    from intersight.model.hyperflex_encryption_relationship import HyperflexEncryptionRelationship
    from intersight.model.hyperflex_health_relationship import HyperflexHealthRelationship
    from intersight.model.hyperflex_license_relationship import HyperflexLicenseRelationship
    from intersight.model.hyperflex_node_relationship import HyperflexNodeRelationship
    from intersight.model.hyperflex_summary import HyperflexSummary
    from intersight.model.ippool_pool_relationship import IppoolPoolRelationship
    from intersight.model.storage_hyper_flex_storage_container_relationship import StorageHyperFlexStorageContainerRelationship
    from intersight.model.storage_hyper_flex_volume_relationship import StorageHyperFlexVolumeRelationship
    from intersight.model.vrf_vrf_relationship import VrfVrfRelationship
    globals()['AssetDeviceRegistrationRelationship'] = AssetDeviceRegistrationRelationship
    globals()['HyperflexAlarmRelationship'] = HyperflexAlarmRelationship
    globals()['HyperflexEncryptionRelationship'] = HyperflexEncryptionRelationship
    globals()['HyperflexHealthRelationship'] = HyperflexHealthRelationship
    globals()['HyperflexLicenseRelationship'] = HyperflexLicenseRelationship
    globals()['HyperflexNodeRelationship'] = HyperflexNodeRelationship
    globals()['HyperflexSummary'] = HyperflexSummary
    globals()['IppoolPoolRelationship'] = IppoolPoolRelationship
    globals()['StorageHyperFlexStorageContainerRelationship'] = StorageHyperFlexStorageContainerRelationship
    globals()['StorageHyperFlexVolumeRelationship'] = StorageHyperFlexVolumeRelationship
    globals()['VrfVrfRelationship'] = VrfVrfRelationship


class HyperflexClusterAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'HYPERFLEX.CLUSTER': "hyperflex.Cluster",
        },
        ('object_type',): {
            'HYPERFLEX.CLUSTER': "hyperflex.Cluster",
        },
        ('upgrade_status',): {
            'UNKNOWN': "Unknown",
            'OK': "Ok",
            'INPROGRESS': "InProgress",
            'FAILED': "Failed",
            'WAITING': "Waiting",
        },
        ('uplink_speed',): {
            'UNKNOWN': "Unknown",
            '10G': "10G",
            '1G': "1G",
        },
        ('zone_type',): {
            'UNKNOWN': "UNKNOWN",
            'NOT_CONFIGURED': "NOT_CONFIGURED",
            'LOGICAL': "LOGICAL",
            'PHYSICAL': "PHYSICAL",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'cluster_type': (int,),  # noqa: E501
            'cluster_uuid': (str,),  # noqa: E501
            'device_id': (str,),  # noqa: E501
            'dns_servers': ([str], none_type,),  # noqa: E501
            'encryption_status': (str,),  # noqa: E501
            'flt_aggr': (int,),  # noqa: E501
            'hxdp_build_version': (str,),  # noqa: E501
            'ntp_servers': ([str], none_type,),  # noqa: E501
            'summary': (HyperflexSummary,),  # noqa: E501
            'upgrade_status': (str,),  # noqa: E501
            'uplink_speed': (str,),  # noqa: E501
            'vm_count': (int,),  # noqa: E501
            'zone_type': (str,),  # noqa: E501
            'alarm': ([HyperflexAlarmRelationship], none_type,),  # noqa: E501
            'encryption': (HyperflexEncryptionRelationship,),  # noqa: E501
            'health': (HyperflexHealthRelationship,),  # noqa: E501
            'license': (HyperflexLicenseRelationship,),  # noqa: E501
            'nodes': ([HyperflexNodeRelationship], none_type,),  # noqa: E501
            'registered_device': (AssetDeviceRegistrationRelationship,),  # noqa: E501
            'storage_client_ip_pools': ([IppoolPoolRelationship], none_type,),  # noqa: E501
            'storage_client_vrf': (VrfVrfRelationship,),  # noqa: E501
            'storage_containers': ([StorageHyperFlexStorageContainerRelationship], none_type,),  # noqa: E501
            'volumes': ([StorageHyperFlexVolumeRelationship], none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'cluster_type': 'ClusterType',  # noqa: E501
        'cluster_uuid': 'ClusterUuid',  # noqa: E501
        'device_id': 'DeviceId',  # noqa: E501
        'dns_servers': 'DnsServers',  # noqa: E501
        'encryption_status': 'EncryptionStatus',  # noqa: E501
        'flt_aggr': 'FltAggr',  # noqa: E501
        'hxdp_build_version': 'HxdpBuildVersion',  # noqa: E501
        'ntp_servers': 'NtpServers',  # noqa: E501
        'summary': 'Summary',  # noqa: E501
        'upgrade_status': 'UpgradeStatus',  # noqa: E501
        'uplink_speed': 'UplinkSpeed',  # noqa: E501
        'vm_count': 'VmCount',  # noqa: E501
        'zone_type': 'ZoneType',  # noqa: E501
        'alarm': 'Alarm',  # noqa: E501
        'encryption': 'Encryption',  # noqa: E501
        'health': 'Health',  # noqa: E501
        'license': 'License',  # noqa: E501
        'nodes': 'Nodes',  # noqa: E501
        'registered_device': 'RegisteredDevice',  # noqa: E501
        'storage_client_ip_pools': 'StorageClientIpPools',  # noqa: E501
        'storage_client_vrf': 'StorageClientVrf',  # noqa: E501
        'storage_containers': 'StorageContainers',  # noqa: E501
        'volumes': 'Volumes',  # noqa: E501
    }

    read_only_vars = {
        'cluster_type',  # noqa: E501
        'cluster_uuid',  # noqa: E501
        'device_id',  # noqa: E501
        'flt_aggr',  # noqa: E501
        'hxdp_build_version',  # noqa: E501
        'upgrade_status',  # noqa: E501
        'uplink_speed',  # noqa: E501
        'vm_count',  # noqa: E501
        'zone_type',  # noqa: E501
        'alarm',  # noqa: E501
        'nodes',  # noqa: E501
        'storage_client_ip_pools',  # noqa: E501
        'storage_containers',  # noqa: E501
        'volumes',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """HyperflexClusterAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "hyperflex.Cluster", must be one of ["hyperflex.Cluster", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "hyperflex.Cluster", must be one of ["hyperflex.Cluster", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            cluster_type (int): The storage type of this cluster (All Flash or Hybrid).. [optional]  # noqa: E501
            cluster_uuid (str): The unique identifier for this HyperFlex cluster.. [optional]  # noqa: E501
            device_id (str): The unique identifier of the device registration that represents this HyperFlex cluster's connection to Intersight.. [optional]  # noqa: E501
            dns_servers ([str], none_type): [optional]  # noqa: E501
            encryption_status (str): This captures the encryption status for a HyperFlex cluster. Currently it will have the status if HXA-CLU-0020 alarm is raised. In the future it can capture other details.. [optional]  # noqa: E501
            flt_aggr (int): The number of yellow (warning) and red (critical) alarms stored as an aggregate. The first 16 bits indicate the number of red alarms, and the last 16 bits contain the number of yellow alarms.. [optional]  # noqa: E501
            hxdp_build_version (str): The version and build number of the HyperFlex Data Platform for this cluster. After a cluster upgrade, this version string will be updated on the next inventory cycle to reflect the newly installed version.. [optional]  # noqa: E501
            ntp_servers ([str], none_type): [optional]  # noqa: E501
            summary (HyperflexSummary): [optional]  # noqa: E501
            upgrade_status (str): The upgrade status of the HyperFlex cluster. * `Unknown` - The upgrade status of the HyperFlex cluster could not be determined. * `Ok` - The upgrade of the HyperFlex cluster is complete. * `InProgress` - The upgrade of the HyperFlex cluster is in-progress. * `Failed` - The upgrade of the HyperFlex cluster has failed. * `Waiting` - The upgrade of the HyperFlex cluster is waiting to continue execution.. [optional] if omitted the server will use the default value of "Unknown"  # noqa: E501
            uplink_speed (str): The uplink speed information of the HyperFlex cluster. * `Unknown` - The uplink speed could not be determined. The physical servers are potentially not claimed. * `10G` - The uplink speed is 10G. * `1G` - The uplink speed is 1G.. [optional] if omitted the server will use the default value of "Unknown"  # noqa: E501
            vm_count (int): The number of virtual machines present on this cluster.. [optional]  # noqa: E501
            zone_type (str): The type of availability zone used by the cluster. Physical zones are always used in HyperFlex  Stretched Clusters. Logical zones may be used if a cluster has Logical Availability Zones (LAZ)  enabled. * `UNKNOWN` - The type of zone configured on the HyperFlex cluster is not known. * `NOT_CONFIGURED` - The zone type is not configured. * `LOGICAL` - The zone is a logical zone created when the logical availability zones (LAZ) feature is enabled on the HyperFlex cluster. * `PHYSICAL` - The zone is a physical zone configured on a stretched HyperFlex cluster.. [optional] if omitted the server will use the default value of "UNKNOWN"  # noqa: E501
            alarm ([HyperflexAlarmRelationship], none_type): An array of relationships to hyperflexAlarm resources.. [optional]  # noqa: E501
            encryption (HyperflexEncryptionRelationship): [optional]  # noqa: E501
            health (HyperflexHealthRelationship): [optional]  # noqa: E501
            license (HyperflexLicenseRelationship): [optional]  # noqa: E501
            nodes ([HyperflexNodeRelationship], none_type): An array of relationships to hyperflexNode resources.. [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
            storage_client_ip_pools ([IppoolPoolRelationship], none_type): An array of relationships to ippoolPool resources.. [optional]  # noqa: E501
            storage_client_vrf (VrfVrfRelationship): [optional]  # noqa: E501
            storage_containers ([StorageHyperFlexStorageContainerRelationship], none_type): An array of relationships to storageHyperFlexStorageContainer resources.. [optional]  # noqa: E501
            volumes ([StorageHyperFlexVolumeRelationship], none_type): An array of relationships to storageHyperFlexVolume resources.. [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "hyperflex.Cluster")
        object_type = kwargs.get('object_type', "hyperflex.Cluster")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """HyperflexClusterAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "hyperflex.Cluster", must be one of ["hyperflex.Cluster", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "hyperflex.Cluster", must be one of ["hyperflex.Cluster", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            cluster_type (int): The storage type of this cluster (All Flash or Hybrid).. [optional]  # noqa: E501
            cluster_uuid (str): The unique identifier for this HyperFlex cluster.. [optional]  # noqa: E501
            device_id (str): The unique identifier of the device registration that represents this HyperFlex cluster's connection to Intersight.. [optional]  # noqa: E501
            dns_servers ([str], none_type): [optional]  # noqa: E501
            encryption_status (str): This captures the encryption status for a HyperFlex cluster. Currently it will have the status if HXA-CLU-0020 alarm is raised. In the future it can capture other details.. [optional]  # noqa: E501
            flt_aggr (int): The number of yellow (warning) and red (critical) alarms stored as an aggregate. The first 16 bits indicate the number of red alarms, and the last 16 bits contain the number of yellow alarms.. [optional]  # noqa: E501
            hxdp_build_version (str): The version and build number of the HyperFlex Data Platform for this cluster. After a cluster upgrade, this version string will be updated on the next inventory cycle to reflect the newly installed version.. [optional]  # noqa: E501
            ntp_servers ([str], none_type): [optional]  # noqa: E501
            summary (HyperflexSummary): [optional]  # noqa: E501
            upgrade_status (str): The upgrade status of the HyperFlex cluster. * `Unknown` - The upgrade status of the HyperFlex cluster could not be determined. * `Ok` - The upgrade of the HyperFlex cluster is complete. * `InProgress` - The upgrade of the HyperFlex cluster is in-progress. * `Failed` - The upgrade of the HyperFlex cluster has failed. * `Waiting` - The upgrade of the HyperFlex cluster is waiting to continue execution.. [optional] if omitted the server will use the default value of "Unknown"  # noqa: E501
            uplink_speed (str): The uplink speed information of the HyperFlex cluster. * `Unknown` - The uplink speed could not be determined. The physical servers are potentially not claimed. * `10G` - The uplink speed is 10G. * `1G` - The uplink speed is 1G.. [optional] if omitted the server will use the default value of "Unknown"  # noqa: E501
            vm_count (int): The number of virtual machines present on this cluster.. [optional]  # noqa: E501
            zone_type (str): The type of availability zone used by the cluster. Physical zones are always used in HyperFlex  Stretched Clusters. Logical zones may be used if a cluster has Logical Availability Zones (LAZ)  enabled. * `UNKNOWN` - The type of zone configured on the HyperFlex cluster is not known. * `NOT_CONFIGURED` - The zone type is not configured. * `LOGICAL` - The zone is a logical zone created when the logical availability zones (LAZ) feature is enabled on the HyperFlex cluster. * `PHYSICAL` - The zone is a physical zone configured on a stretched HyperFlex cluster.. [optional] if omitted the server will use the default value of "UNKNOWN"  # noqa: E501
            alarm ([HyperflexAlarmRelationship], none_type): An array of relationships to hyperflexAlarm resources.. [optional]  # noqa: E501
            encryption (HyperflexEncryptionRelationship): [optional]  # noqa: E501
            health (HyperflexHealthRelationship): [optional]  # noqa: E501
            license (HyperflexLicenseRelationship): [optional]  # noqa: E501
            nodes ([HyperflexNodeRelationship], none_type): An array of relationships to hyperflexNode resources.. [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
            storage_client_ip_pools ([IppoolPoolRelationship], none_type): An array of relationships to ippoolPool resources.. [optional]  # noqa: E501
            storage_client_vrf (VrfVrfRelationship): [optional]  # noqa: E501
            storage_containers ([StorageHyperFlexStorageContainerRelationship], none_type): An array of relationships to storageHyperFlexStorageContainer resources.. [optional]  # noqa: E501
            volumes ([StorageHyperFlexVolumeRelationship], none_type): An array of relationships to storageHyperFlexVolume resources.. [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "hyperflex.Cluster")
        object_type = kwargs.get('object_type', "hyperflex.Cluster")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
