"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-11558
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.fabric_fc_zone_policy_relationship import FabricFcZonePolicyRelationship
    from intersight.model.fcpool_lease_relationship import FcpoolLeaseRelationship
    from intersight.model.fcpool_pool_relationship import FcpoolPoolRelationship
    from intersight.model.vnic_fc_adapter_policy_inventory_relationship import VnicFcAdapterPolicyInventoryRelationship
    from intersight.model.vnic_fc_if_inventory_relationship import VnicFcIfInventoryRelationship
    from intersight.model.vnic_fc_network_policy_inventory_relationship import VnicFcNetworkPolicyInventoryRelationship
    from intersight.model.vnic_fc_qos_policy_inventory_relationship import VnicFcQosPolicyInventoryRelationship
    from intersight.model.vnic_placement_settings import VnicPlacementSettings
    from intersight.model.vnic_san_connectivity_policy_inventory_relationship import VnicSanConnectivityPolicyInventoryRelationship
    globals()['FabricFcZonePolicyRelationship'] = FabricFcZonePolicyRelationship
    globals()['FcpoolLeaseRelationship'] = FcpoolLeaseRelationship
    globals()['FcpoolPoolRelationship'] = FcpoolPoolRelationship
    globals()['VnicFcAdapterPolicyInventoryRelationship'] = VnicFcAdapterPolicyInventoryRelationship
    globals()['VnicFcIfInventoryRelationship'] = VnicFcIfInventoryRelationship
    globals()['VnicFcNetworkPolicyInventoryRelationship'] = VnicFcNetworkPolicyInventoryRelationship
    globals()['VnicFcQosPolicyInventoryRelationship'] = VnicFcQosPolicyInventoryRelationship
    globals()['VnicPlacementSettings'] = VnicPlacementSettings
    globals()['VnicSanConnectivityPolicyInventoryRelationship'] = VnicSanConnectivityPolicyInventoryRelationship


class VnicFcIfInventoryAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'VNIC.FCIFINVENTORY': "vnic.FcIfInventory",
        },
        ('object_type',): {
            'VNIC.FCIFINVENTORY': "vnic.FcIfInventory",
        },
        ('type',): {
            'INITIATOR': "fc-initiator",
            'NVME-INITIATOR': "fc-nvme-initiator",
            'NVME-TARGET': "fc-nvme-target",
            'TARGET': "fc-target",
        },
        ('wwpn_address_type',): {
            'POOL': "POOL",
            'STATIC': "STATIC",
        },
    }

    validations = {
        ('name',): {
            'max_length': 31,
            'regex': {
                'pattern': r'^[a-zA-Z0-9\-\._:]+$',  # noqa: E501
            },
        },
        ('pin_group_name',): {
            'regex': {
                'pattern': r'^$|^[a-zA-Z0-9_.:-]{1,64}$',  # noqa: E501
            },
        },
        ('static_wwpn_address',): {
            'regex': {
                'pattern': r'^$|((^20|5[0-9a-fA-F]{1}):([0-9a-fA-F]{2}:){6}([0-9a-fA-F]{2})$)',  # noqa: E501
            },
        },
        ('wwpn',): {
            'regex': {
                'pattern': r'^$|((^20|5[0-9a-fA-F]{1}):([0-9a-fA-F]{2}:){6}([0-9a-fA-F]{2})$)',  # noqa: E501
            },
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'order': (int,),  # noqa: E501
            'persistent_bindings': (bool,),  # noqa: E501
            'pin_group_name': (str,),  # noqa: E501
            'placement': (VnicPlacementSettings,),  # noqa: E501
            'static_wwpn_address': (str,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'vif_id': (int,),  # noqa: E501
            'wwpn': (str,),  # noqa: E501
            'wwpn_address_type': (str,),  # noqa: E501
            'fc_adapter_policy': (VnicFcAdapterPolicyInventoryRelationship,),  # noqa: E501
            'fc_network_policy': (VnicFcNetworkPolicyInventoryRelationship,),  # noqa: E501
            'fc_qos_policy': (VnicFcQosPolicyInventoryRelationship,),  # noqa: E501
            'fc_zone_policies': ([FabricFcZonePolicyRelationship], none_type,),  # noqa: E501
            'san_connectivity_policy': (VnicSanConnectivityPolicyInventoryRelationship,),  # noqa: E501
            'scp_vhba': (VnicFcIfInventoryRelationship,),  # noqa: E501
            'sp_vhbas': ([VnicFcIfInventoryRelationship], none_type,),  # noqa: E501
            'wwpn_lease': (FcpoolLeaseRelationship,),  # noqa: E501
            'wwpn_pool': (FcpoolPoolRelationship,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'name': 'Name',  # noqa: E501
        'order': 'Order',  # noqa: E501
        'persistent_bindings': 'PersistentBindings',  # noqa: E501
        'pin_group_name': 'PinGroupName',  # noqa: E501
        'placement': 'Placement',  # noqa: E501
        'static_wwpn_address': 'StaticWwpnAddress',  # noqa: E501
        'type': 'Type',  # noqa: E501
        'vif_id': 'VifId',  # noqa: E501
        'wwpn': 'Wwpn',  # noqa: E501
        'wwpn_address_type': 'WwpnAddressType',  # noqa: E501
        'fc_adapter_policy': 'FcAdapterPolicy',  # noqa: E501
        'fc_network_policy': 'FcNetworkPolicy',  # noqa: E501
        'fc_qos_policy': 'FcQosPolicy',  # noqa: E501
        'fc_zone_policies': 'FcZonePolicies',  # noqa: E501
        'san_connectivity_policy': 'SanConnectivityPolicy',  # noqa: E501
        'scp_vhba': 'ScpVhba',  # noqa: E501
        'sp_vhbas': 'SpVhbas',  # noqa: E501
        'wwpn_lease': 'WwpnLease',  # noqa: E501
        'wwpn_pool': 'WwpnPool',  # noqa: E501
    }

    read_only_vars = {
        'name',  # noqa: E501
        'order',  # noqa: E501
        'persistent_bindings',  # noqa: E501
        'pin_group_name',  # noqa: E501
        'static_wwpn_address',  # noqa: E501
        'type',  # noqa: E501
        'vif_id',  # noqa: E501
        'wwpn',  # noqa: E501
        'wwpn_address_type',  # noqa: E501
        'fc_zone_policies',  # noqa: E501
        'sp_vhbas',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """VnicFcIfInventoryAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "vnic.FcIfInventory", must be one of ["vnic.FcIfInventory", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "vnic.FcIfInventory", must be one of ["vnic.FcIfInventory", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            name (str): Name of the virtual fibre channel interface.. [optional]  # noqa: E501
            order (int): The order in which the virtual interface is brought up. The order assigned to an interface should be unique for all the Ethernet and Fibre-Channel interfaces on each PCI link on a VIC adapter. The maximum value of PCI order is limited by the number of virtual interfaces (Ethernet and Fibre-Channel) on each PCI link on a VIC adapter. All VIC adapters have a single PCI link except VIC 1385 which has two.. [optional]  # noqa: E501
            persistent_bindings (bool): Enables retention of LUN ID associations in memory until they are manually cleared.. [optional]  # noqa: E501
            pin_group_name (str): Pingroup name associated to vfc for static pinning. SCP deploy will resolve pingroup name and fetches the correspoding uplink port/port channel to pin the vfc traffic.. [optional]  # noqa: E501
            placement (VnicPlacementSettings): [optional]  # noqa: E501
            static_wwpn_address (str): The WWPN address must be in hexadecimal format xx:xx:xx:xx:xx:xx:xx:xx. Allowed ranges are 20:00:00:00:00:00:00:00 to 20:FF:FF:FF:FF:FF:FF:FF or from 50:00:00:00:00:00:00:00 to 5F:FF:FF:FF:FF:FF:FF:FF. To ensure uniqueness of WWN's in the SAN fabric, you are strongly encouraged to use the WWN prefix - 20:00:00:25:B5:xx:xx:xx.. [optional]  # noqa: E501
            type (str): VHBA Type configuration for SAN Connectivity Policy. This configuration is supported only on Cisco VIC 14XX series and higher series of adapters. * `fc-initiator` - The default value set for vHBA Type Configuration. Fc-initiator specifies vHBA as a consumer of storage. Enables SCSI commands to transfer data and status information between host and target storage systems. * `fc-nvme-initiator` - Fc-nvme-initiator specifies vHBA as a consumer of storage. Enables NVMe-based message commands to transfer data and status information between host and target storage systems. * `fc-nvme-target` - Fc-nvme-target specifies vHBA as a provider of storage volumes to initiators. Enables NVMe-based message commands to transfer data and status information between host and target storage systems. Currently tech-preview, only enabled with an asynchronous driver. * `fc-target` - Fc-target specifies vHBA as a provider of storage volumes to initiators. Enables SCSI commands to transfer data and status information between host and target storage systems. fc-target is enabled only with an asynchronous driver.. [optional] if omitted the server will use the default value of "fc-initiator"  # noqa: E501
            vif_id (int): This should be the same as the channel number of the vfc created on switch in order to set up the data path. The property is applicable only for FI attached servers where a vfc is created on the switch for every vHBA.. [optional]  # noqa: E501
            wwpn (str): The WWPN address that is assigned to the vHBA based on the wwn pool that has been assigned to the SAN Connectivity Policy.. [optional]  # noqa: E501
            wwpn_address_type (str): Type of allocation selected to assign a WWPN address to the vhba. * `POOL` - The user selects a pool from which the mac/wwn address will be leased for the Virtual Interface. * `STATIC` - The user assigns a static mac/wwn address for the Virtual Interface.. [optional] if omitted the server will use the default value of "POOL"  # noqa: E501
            fc_adapter_policy (VnicFcAdapterPolicyInventoryRelationship): [optional]  # noqa: E501
            fc_network_policy (VnicFcNetworkPolicyInventoryRelationship): [optional]  # noqa: E501
            fc_qos_policy (VnicFcQosPolicyInventoryRelationship): [optional]  # noqa: E501
            fc_zone_policies ([FabricFcZonePolicyRelationship], none_type): An array of relationships to fabricFcZonePolicy resources.. [optional]  # noqa: E501
            san_connectivity_policy (VnicSanConnectivityPolicyInventoryRelationship): [optional]  # noqa: E501
            scp_vhba (VnicFcIfInventoryRelationship): [optional]  # noqa: E501
            sp_vhbas ([VnicFcIfInventoryRelationship], none_type): An array of relationships to vnicFcIfInventory resources.. [optional]  # noqa: E501
            wwpn_lease (FcpoolLeaseRelationship): [optional]  # noqa: E501
            wwpn_pool (FcpoolPoolRelationship): [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "vnic.FcIfInventory")
        object_type = kwargs.get('object_type', "vnic.FcIfInventory")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """VnicFcIfInventoryAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "vnic.FcIfInventory", must be one of ["vnic.FcIfInventory", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "vnic.FcIfInventory", must be one of ["vnic.FcIfInventory", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            name (str): Name of the virtual fibre channel interface.. [optional]  # noqa: E501
            order (int): The order in which the virtual interface is brought up. The order assigned to an interface should be unique for all the Ethernet and Fibre-Channel interfaces on each PCI link on a VIC adapter. The maximum value of PCI order is limited by the number of virtual interfaces (Ethernet and Fibre-Channel) on each PCI link on a VIC adapter. All VIC adapters have a single PCI link except VIC 1385 which has two.. [optional]  # noqa: E501
            persistent_bindings (bool): Enables retention of LUN ID associations in memory until they are manually cleared.. [optional]  # noqa: E501
            pin_group_name (str): Pingroup name associated to vfc for static pinning. SCP deploy will resolve pingroup name and fetches the correspoding uplink port/port channel to pin the vfc traffic.. [optional]  # noqa: E501
            placement (VnicPlacementSettings): [optional]  # noqa: E501
            static_wwpn_address (str): The WWPN address must be in hexadecimal format xx:xx:xx:xx:xx:xx:xx:xx. Allowed ranges are 20:00:00:00:00:00:00:00 to 20:FF:FF:FF:FF:FF:FF:FF or from 50:00:00:00:00:00:00:00 to 5F:FF:FF:FF:FF:FF:FF:FF. To ensure uniqueness of WWN's in the SAN fabric, you are strongly encouraged to use the WWN prefix - 20:00:00:25:B5:xx:xx:xx.. [optional]  # noqa: E501
            type (str): VHBA Type configuration for SAN Connectivity Policy. This configuration is supported only on Cisco VIC 14XX series and higher series of adapters. * `fc-initiator` - The default value set for vHBA Type Configuration. Fc-initiator specifies vHBA as a consumer of storage. Enables SCSI commands to transfer data and status information between host and target storage systems. * `fc-nvme-initiator` - Fc-nvme-initiator specifies vHBA as a consumer of storage. Enables NVMe-based message commands to transfer data and status information between host and target storage systems. * `fc-nvme-target` - Fc-nvme-target specifies vHBA as a provider of storage volumes to initiators. Enables NVMe-based message commands to transfer data and status information between host and target storage systems. Currently tech-preview, only enabled with an asynchronous driver. * `fc-target` - Fc-target specifies vHBA as a provider of storage volumes to initiators. Enables SCSI commands to transfer data and status information between host and target storage systems. fc-target is enabled only with an asynchronous driver.. [optional] if omitted the server will use the default value of "fc-initiator"  # noqa: E501
            vif_id (int): This should be the same as the channel number of the vfc created on switch in order to set up the data path. The property is applicable only for FI attached servers where a vfc is created on the switch for every vHBA.. [optional]  # noqa: E501
            wwpn (str): The WWPN address that is assigned to the vHBA based on the wwn pool that has been assigned to the SAN Connectivity Policy.. [optional]  # noqa: E501
            wwpn_address_type (str): Type of allocation selected to assign a WWPN address to the vhba. * `POOL` - The user selects a pool from which the mac/wwn address will be leased for the Virtual Interface. * `STATIC` - The user assigns a static mac/wwn address for the Virtual Interface.. [optional] if omitted the server will use the default value of "POOL"  # noqa: E501
            fc_adapter_policy (VnicFcAdapterPolicyInventoryRelationship): [optional]  # noqa: E501
            fc_network_policy (VnicFcNetworkPolicyInventoryRelationship): [optional]  # noqa: E501
            fc_qos_policy (VnicFcQosPolicyInventoryRelationship): [optional]  # noqa: E501
            fc_zone_policies ([FabricFcZonePolicyRelationship], none_type): An array of relationships to fabricFcZonePolicy resources.. [optional]  # noqa: E501
            san_connectivity_policy (VnicSanConnectivityPolicyInventoryRelationship): [optional]  # noqa: E501
            scp_vhba (VnicFcIfInventoryRelationship): [optional]  # noqa: E501
            sp_vhbas ([VnicFcIfInventoryRelationship], none_type): An array of relationships to vnicFcIfInventory resources.. [optional]  # noqa: E501
            wwpn_lease (FcpoolLeaseRelationship): [optional]  # noqa: E501
            wwpn_pool (FcpoolPoolRelationship): [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "vnic.FcIfInventory")
        object_type = kwargs.get('object_type', "vnic.FcIfInventory")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
